# wxUIActionSimulator Class Reference

`#include <wx/uiaction.h>`

## Detailed Description

wxUIActionSimulator is a class used to simulate user interface actions such as a mouse click or a key press.

Common usage for this class would be to provide playback and record (aka macro recording) functionality for users, or to drive unit tests by simulating user sessions.

See the wxUIActionSimulator Sample for an example of using this class.

Since:
  2.9.2

##

Library: wxCore

## Public Member Functions
| wxUIActionSimulator ()
| Default constructor.
bool | MouseMove (long x, long y)
| Move the mouse to the specified coordinates.
bool | MouseMove (const wxPoint &point)
| Move the mouse to the specified coordinates.
bool | MouseDown (int button=wxMOUSE_BTN_LEFT)
| Press a mouse button.
bool | MouseUp (int button=wxMOUSE_BTN_LEFT)
| Release a mouse button.
bool | MouseClick (int button=wxMOUSE_BTN_LEFT)
| Click a mouse button.
bool | MouseDblClick (int button=wxMOUSE_BTN_LEFT)
| Double-click a mouse button.
bool | MouseDragDrop (long x1, long y1, long x2, long y2, int button=wxMOUSE_BTN_LEFT)
| Perform a drag and drop operation.
bool | KeyDown (int keycode, int modifiers=wxMOD_NONE)
| Press a key.
bool | KeyUp (int keycode, int modifiers=wxMOD_NONE)
| Release a key.
bool | Char (int keycode, int modifiers=wxMOD_NONE)
| Press and release a key.
bool | Text (const wxString &text)
| Emulate typing in the keys representing the given string.

List of all members.

## Constructor & Destructor Documentation

wxUIActionSimulator::wxUIActionSimulator | ( |  | ) |

Default constructor.

## Member Function Documentation

bool wxUIActionSimulator::Char | ( | int | keycode,
|  | int | modifiers = `wxMOD_NONE` |
| ) |  |  |

Press and release a key.

Parameters:

  | keycode | Key to operate on, as an integer. It is interpreted as a wxKeyCode.
  | modifiers | A combination of wxKeyModifier flags to be pressed with the given keycode.

bool wxUIActionSimulator::KeyDown | ( | int | keycode,
|  | int | modifiers = `wxMOD_NONE` |
| ) |  |  |

Press a key.

If you are using modifiers then it needs to be paired with an identical KeyUp or the modifiers will not be released (MSW and OSX).

Parameters:

  | keycode | Key to operate on, as an integer. It is interpreted as a wxKeyCode.
  | modifiers | A combination of wxKeyModifier flags to be pressed with the given keycode.

bool wxUIActionSimulator::KeyUp | ( | int | keycode,
|  | int | modifiers = `wxMOD_NONE` |
| ) |  |  |

Release a key.

Parameters:

  | keycode | Key to operate on, as an integer. It is interpreted as a wxKeyCode.
  | modifiers | A combination of wxKeyModifier flags to be pressed with the given keycode.

bool wxUIActionSimulator::MouseClick | ( | int | button = `wxMOUSE_BTN_LEFT` | ) |

Click a mouse button.

Parameters:

  | button | Button to press. See wxUIActionSimulator::MouseDown for a list of valid constants.

bool wxUIActionSimulator::MouseDblClick | ( | int | button = `wxMOUSE_BTN_LEFT` | ) |

Double-click a mouse button.

Parameters:

  | button | Button to press. See wxUIActionSimulator::MouseDown for a list of valid constants.

bool wxUIActionSimulator::MouseDown | ( | int | button = `wxMOUSE_BTN_LEFT` | ) |

Press a mouse button.

Parameters:

  | button | Button to press. Valid constants are `wxMOUSE_BTN_LEFT`, `wxMOUSE_BTN_MIDDLE`, and `wxMOUSE_BTN_RIGHT`.

bool wxUIActionSimulator::MouseDragDrop | ( | long | x1,
|  | long | y1,
|  | long | x2,
|  | long | y2,
|  | int | button = `wxMOUSE_BTN_LEFT` |
| ) |  |  |

Perform a drag and drop operation.

Parameters:

  | x1 | x start coordinate, in screen coordinates.
  | y1 | y start coordinate, in screen coordinates.
  | x2 | x destination coordinate, in screen coordinates.
  | y2 | y destination coordinate, in screen coordinates.
  | button | Button to press. See wxUIActionSimulator::MouseDown for a list of valid constants.

bool wxUIActionSimulator::MouseMove | ( | const wxPoint & | point | ) |

Move the mouse to the specified coordinates.

Parameters:

  | point | Point to move to, in screen coordinates.

bool wxUIActionSimulator::MouseMove | ( | long | x,
|  | long | y |
| ) |  |  |

Move the mouse to the specified coordinates.

Parameters:

  | x | x coordinate to move to, in screen coordinates.
  | y | y coordinate to move to, in screen coordinates.

bool wxUIActionSimulator::MouseUp | ( | int | button = `wxMOUSE_BTN_LEFT` | ) |

Release a mouse button.

Parameters:

  | button | Button to press. See wxUIActionSimulator::MouseDown for a list of valid constants.

bool wxUIActionSimulator::Text | ( | const wxString & | text | ) |

Emulate typing in the keys representing the given string.

Currently only the ASCII letters (i.e. characters `a-z` and `A-Z`) are supported.

Parameters:

  | text | The string to type.

|  | [ top ]